Page MenuHomePhabricator

Linking Workboard lanes to Task activities
Closed, WontfixPublic

Description

At my company, we like to use Kanban style Workboards to keep track of what the team is currently working on; in addition to the standard Backlog land, we have "In Progress", "In Review", and "Done":

  • When someone starts working on a Task, they move it from Backlog to In Progress.
  • When they create a Differential for a Task, they move it from In Progress to In Review.
  • When they land their changes onto our main branch, they move it from In Review to Done.

Unfortunately, we're lazy and usually forget to move things between lanes, especially when a Task is tagged with several Projects. If we had a project manager, they'd be complaining about the state of our Workboard constantly.

It would be great if these lane transitions could be handled automatically by Phabricator/arc:

  • Feature branch created for a Task; move it to In Progress in whatever boards it's on.
  • arc diff for a Task; move it to In Review in whatever boards it's on.
  • arc land for a Task; move it to Done in whatever boards it's on.

This almost seems like something Herald could handle, but it doesn't seem to support moving Tasks between Workboard lanes.

Event Timeline

Taffer created this task.May 26 2016, 2:44 PM

I don't understand the root problem this is seeking to solve. Please read Describing Root Problems carefully and try to follow the instructions there to describe a problem we can solve.

I think this is the closest thing to a root problem description here, but it's still far away from a root problem (why would they complain?) and actually describes a non-problem:

If we had a project manager, they'd be complaining about the state of our Workboard constantly.

chad added a subscriber: chad.May 26 2016, 2:58 PM

I think anything automatic here would likely only be truly correct maybe 50% of the time, and I think that's really bad from an accuracy perspective if that's what's important to your company. I'd rather look at what information is actually missing from the workboard cards (ie, diff attached) and explore options there.

This seems related to T5474: Support workboard column triggers which activate when a task is dropped into a column.

I understand what @Taffer is going for here. My organization uses workboards for communicating task and project status outside of the engineering team, so making sure that a task is in the proper column on multiple workboards is important to allowing others (who aren't as fluent in Phabricator and/or don't have the time to dig deep into many ongoing projects) to keep abreast of project and sprint status, but it's also a manual process and prone to errors (e.g. forgetting to update one of the workboards a task is in), leading to misunderstandings. Allowing some sort of automation of these types of actions reduces the chance for manual error, which makes people outside of the engineering team happier, which makes my life (and my engineers' lives) easier.

At the risk of being redundant, perhaps the root problem statement is: "We're having trouble using workboards to accurately reflect the day-to-day progress towards milestones and project completion, because keeping them up-to-date is a manual process, our engineers are forgetful, and task statuses that should be reflected on workboards can be changed by actions elsewhere."

Sorry, the Root Problem would be something like:

Developers don't remember to update the Workboard while working on a Task; it would be nice to provide some support for them so the Workboard is more useful as a communication tool.

@rfreebern hit the nail on the head. This is for communicating to the rest of the team, and outside the team to people who can't/won't dig into the repo to see what's going on.

chad added a comment.May 27 2016, 2:42 AM

I think we've shot down other requests in this vein (Herald + Workboards) due to overwhelming interest in T5474, which would likely be prohibitive or insanely complicated to support if Herald was in the mix.

For instance arc land plus Fixes T123 in the commit message today automatically closes the task, but in the "Done" column example, it wouldn't display by default since the task was closed. In general if you want to see completed tasks, you can use the sorting functionality on the board, which means "Done" isn't really even needed as a column.

Overall I think "we want more status information automatic on a Workboard card" is better solved with T4863, which we could add (optionally) additonal information to cards, like if it is blocking other tasks, has diffs out for review, subtasks, pholio mocks, etc.

chad closed this task as Wontfix.Jun 1 2016, 7:51 PM
chad claimed this task.

Roughly, I think T10333, T5474, and T4863 are leading the way to making boards more magical and PM friendly. I would want to continue on and build those first and see if most of what you want could already be accomplished with those features. Since this request is mostly hypothetical, I'm going to close it out for now and we can revisit things down the road.